using System.Collections.ObjectModel;
using System.Diagnostics;
using CODE.Framework.Wpf.Documents;
using CODE.Framework.Wpf.Mvvm;

namespace DocumentExamples.Models.Print
{
    public class ProductCatalogViewModel : ViewModel
    {
        public ProductCatalogViewModel()
        {
            Products = new ObservableCollection<StandardViewModel>
                {
                    new StandardViewModel
                        {
                            Text1 = "Quad Wave",
                            Text2 = "Sizes available:\r\n68 | 72 | 78 | 84 | 92 | 104",
                            Text3 = "The new Custom Quads bring dedicated surfing experience into wavesailing, with a wider wind range, more drive, added upwind and all around faster riding. From hard core down the line conditions to onshore chop, these boards are built to go beyond what you though it was possible.\r\n\r\nThe Goya Quad concept allows you to increase the volume of the board about 5 liters above what you would normally ride, with absolutely no loss of control in the high end. The result is a board with a massively expanded wind range- that extra volume will keep you moving through lulls that a lower volume board might slow down in.\r\n\r\nThe Custom PRO features generous carbon patching from in front of the mast track all the way into the tail, as well as beneath and around the padded areas.\r\n\r\nThe most recent range of the Custom is seriously extended in both directions small and large, by adding a 68 liter high wind board that will suit smaller riders like a magic glove, and by a whopping 104 liter model that redefines how we will approach light wind days. Imagine taking all of its agility and volume into one of those days where waves are beyond mast high, but winds used to only allow you to reach for non-bottom-turnable Freerides, Freestyles or even SUPs in the past. Now your epic Quad light wind match is here. Go for it.",
                            Text4 = "http://d2z2i12dpvcgkc.cloudfront.net/wp-content/uploads/2012/09/boards_2013_custom_rendering.jpg"
                        },
                    new StandardViewModel
                        {
                            Text1 = "Wave & Ride",
                            Text2 = "Sizes available:\r\n72 | 78 | 86 | 94 | 104 | 116 | 130 | 144",
                            Text3 = "If you are looking for one board that can do it all, look no further. The One is fast, turny, easy to ride, for all styles and all conditions. Welcome to a real one board concept. Just pick your volume and go windsurfing. Done. The ONE combines the best features of all board lines we have yet been producing, and merges them into what is now becoming an instant favorite among riders and testers.\r\n\r\nThe One PRO 72 and 78 liter models feature generous carbon patching from in front of the mast track all the way into the tail, as well as beneath and around the padded areas.\r\n\r\nAS IF THAT WASNT ENOUGH, THE 72, 78 AND 86 MODELS NOW COME AS THRUSTERS, GIVING YOU MORE CONTROL IN SURFING TURNS WHILE MAINTAINING THE FORWARD DRIVE OF A SINGLE FIN DESIGN. THE BEST OF BOTH WORLDS.\r\n\r\nThe One 72 has a concave into double concave shape for added control and grip. The One 78 offers more lift and power and therefore transitions from a V into a double Concave. All succeeding boards carry a V bottom with double concaves through the stance. V bottoms are the fastests bottoms, and the double concave accentuate the centerline, softening the ride and making it more comfortable while adding crispy grip and drive to the turns.\r\n\r\nThe smaller sizes 72, 78 and 86 feature a center US Box compatible with all wave fin designs and the larger sizes 94, 104, 116, 130 and 144 feature a Power Box for increased speed, strength and compatibility with larger fins.",
                            Text4 = "http://d2z2i12dpvcgkc.cloudfront.net/wp-content/uploads/2012/09/boards_2013_one_pro_render_2.jpg"
                        },
                    new StandardViewModel
                        {
                            Text1 = "Wave & Ride",
                            Text2 = "Sizes available:\r\n86 | 94 | 104 | 116 | 130 | 144",
                            Text3 = "If you are looking for one board that can do it all, look no further. The ONE is fast, turny, easy to ride, for all styles and all conditions. Welcome to a real one board concept. Just pick your volume and go windsurfing. Done.\r\n\r\nThe ONE combines the best features of all board lines we have yet been producing, and merges them into what is now becoming an instant favorite among riders and testers.\r\n\r\nThe ONE 86-104 carry a V bottom with double concaves through the stance. The reason for that is that V bottoms are the fastests bottoms still, all raceboards carry them and the double concave accentuate the centerline, softening the ride/ more comfortable while adding grip and drive to the turns.\r\n\r\nThe 86 features a US Box compatible with all wave fin designs and the larger sizes 94, 104, 116, 130 and 144 feature a Power Box for increase speed, strength and compatibility with larger fins.",
                            Text4 = "http://d2z2i12dpvcgkc.cloudfront.net/wp-content/uploads/2012/09/boards-2013-one-eco.jpg"
                        },
                    new StandardViewModel
                        {
                            Text1 = "Free-Style",
                            Text2 = "Sizes available:\r\n99",
                            Text3 = "NOTE: THE AIR COMES IN BOTH NEON GREEN AND NEON YELLOW FINISH FOR A LIMITED TIME. BOTH ARE GENUINE. BOTH ARE GOYA. THERES NO DIFFERENCE. THEY ARE EQUALLY FUN.\r\n\r\nThis airborne Freestyle board, is exclusively designed for the generation of freestyle moves that we now see on the water and aspire ourselves. These boards are not just tested but used and abused daily by professional Freestyle riders on Maui and around the globe.\r\n\r\nThe all new short shape combines extreme power and pop for air moves while keeping full rail carving capabilities. The rocker with a longer flat section is only surpassed by our Freerace line, focussing on early planning and top end speed. The gradual nose rocker has been reduced for control and ease when switching from tail to nose glides.\r\n\r\nThe Air PRO features generous carbon patching from in front of the mast track all the way into the tail, as well as beneath and around the padded areas.\r\n\r\nFurther design features include an increased tail volume and bevel for reverse sliding tricks as well as Freestyle insert positions with double screws on the back strap.\r\n\r\nFeatures\r\n\r\nGradual curved deck under the foot strap area and customized Freestyle insert positions with double screws on the back strap.",
                            Text4 = "http://d2z2i12dpvcgkc.cloudfront.net/wp-content/uploads/2012/09/boards-2013-air-render.jpg"
                        },
                };

            Actions.Add(new ViewAction("Save", significance: ViewActionSignificance.AboveNormal, brushResourceKey: "CODE.Framework-Icon-Save", execute: (a, o) =>
            {
                var doc = Controller.GetDocumentForModel(this);
                if (doc == null) return;
                doc.SaveAsXps(@"d:\Test.xps");
                Process.Start(@"d:\Test.xps");
            }));
            Actions.Add(new ViewAction("Print", significance: ViewActionSignificance.AboveNormal, brushResourceKey: "CODE.Framework-Icon-Print", execute: (a, o) =>
            {
                var doc = Controller.GetDocumentForModel(this);
                if (doc == null) return;
                doc.Print();
            }));
            Actions.Add(new CloseCurrentViewAction(this, beginGroup: true) { Significance = ViewActionSignificance.AboveNormal });

            Controller.Status("Ready.");
        }

        public ObservableCollection<StandardViewModel> Products { get; set; }
    }
}
